#include <iostream>

using namespace std;

int main()
{
    int n;
    cin>>n;
    int O=0;
     int A=0;
      int B=0;
       int AB=0;
    cin>>O>>A>>B>>AB;
    int O1[n];
    int A1[n];
    int B1[n];
    int AB1[n];
    int O2=0, A2=0,B2=0,AB2=0;
    string grupa[n];
    int jedinice[n];
    for(int i=0;i<n;i++)
    {
       string s;
       int a;
       cin>>s>>a;
       grupa[i]=s;
       jedinice[i]=a;
       if(s=="O")
       {
         O2+=a;
       }
       if(s=="A")
       {
         A2+=a;
       }
       if(s=="B")
       {
         B2+=a;
       }
       if(s=="AB")
       {
         AB2+=a;
       }
    }
    bool b=true;
    if(O<O2)
    {
       cout<<"nemoguce";
       b=false;
    }
    else
    {
        if(A2>A+O-O2)
        {
         cout<<"nemoguce";
         b=false;
        }
        else
        {
          if(B2>B+O-O2)
           {
             cout<<"nemoguce";
             b=false;
           }
           else
           {
                 if(A2+B2>A+B+O-O2)
                     {
                       cout<<"nemoguce";
                       b=false;
                     }
                     else
                     {
                         if(A2+B2+O2+AB2>A+B+O+AB)
                         {
                             cout<<"nemoguce";
                             b=false;
                         }
                     }
           }
        }

    }
    int O3=O-O2;
    int A3;
    if(A>A2)
    {
        A3=A-A2;
    }
    else
    {
        O3=O-A2+A;
        A3=0;
    }
    int B3;
    if(B>B2)
    {
        B3=B-B2;
    }
    else
    {
        O3=O-B2+B;
        B3=0;
    }
    if(b==true)
    {
        for(int i=0;i<n;i++)
        {
            if(grupa[i]=="O")
            {
                O-=jedinice[i];
                O1[i]=jedinice[i];
                A1[i]=0;
                B1[i]=0;
                AB1[i]=0;
            }
            else
            {
                if(grupa[i]=="A")
                {
                    if(A>=jedinice[i])
                    {
                        A-=jedinice[i];
                        A1[i]=jedinice[i];
                        B1[i]=0;
                        O1[i]=0;
                        AB1[i]=0;
                    }
                    else
                    {

                        O=O-jedinice[i]+A;
                         A1[i]=A;
                        B1[i]=0;
                        O1[i]=jedinice[i]-A;
                        AB1[i]=0;
                        A=0;

                    }
                }
                else
                {
                    if(grupa[i]=="B")
                {
                    if(B>=jedinice[i])
                    {
                        B=jedinice[i];
                        A1[i]=0;
                        B1[i]=jedinice[i];
                        O1[i]=0;
                        AB1[i]=0;
                    }
                    else
                    {

                        O=O-jedinice[i]+B;
                         A1[i]=0;
                        B1[i]=B;
                        O1[i]=jedinice[i]-B;
                        AB1[i]=0;
                        B=0;

                    }
                }
                 else
            {
                if(AB>=jedinice[i])
                {
                    AB-=jedinice[i];
                     A1[i]=0;
                        B1[i]=0;
                        O1[i]=0;
                        AB1[i]=jedinice[i];
                }
                else
                {
                    AB1[i]=AB;
                    jedinice[i]=jedinice[i]-AB;
                    AB=0;
                    if(jedinice[i]<A3)
                    {
                        A1[i]=jedinice[i];
                        B1[i]=0;
                        O1[i]=0;
                        A3=A3-jedinice[i];
                    }
                    else
                    {
                        A1[i]=A3;
                        jedinice[i]=jedinice[i]-A3;
                        A3=0;
                        if(jedinice[i]<B3)
                        {
                            B1[i]=jedinice[i];
                            O1[i]=0;
                            B3=B3-jedinice[i];
                        }
                        else
                        {
                            B1[i]=B3;
                            O1[i]=jedinice[i]-B3;
                            O3=O3-jedinice[i]+B3;
                            B3=0;
                        }
                    }
                }
            }
            }


        }
    }
    }
    if(b==true)
    {
       cout<<"moguce"<<endl;
       for(int i=0;i<n;i++)
      {
        cout<<O1[i]<<" "<<A1[i]<<" "<<B1[i]<<" "<<AB1[i]<<endl;
      }
    }

    return 0;
}